%{!?dotests: %define dotests 1}
Summary: A perfect hash function generator
Name: gperf
Version: 3.1
Release: 1
License: GPL-3.0-or-later
Source: https://ftp.gnu.org/pub/gnu/gperf/gperf-%{version}.tar.gz
URL:    https://www.gnu.org/software/gperf/

BuildRequires:  gcc >= 10
BuildRequires:  gcc-c++ >= 10
BuildRequires:  gzip >= 1.12

%if %{toolchain} == "gcc"
Requires: libgcc >= 10.3.0
Requires: libstdc++ >= 10.3.0
%endif


%description
Gperf is a perfect hash function generator written in C++. Simply
stated, a perfect hash function is a hash function and a data
structure that allows recognition of a key word in a set of words
using exactly one probe into the data structure.

%prep
%setup -q
rm -rf   /tmp/%{name}-%{version}-32bit
cp -pr . /tmp/%{name}-%{version}-32bit
rm -fr *
mv       /tmp/%{name}-%{version}-32bit 32bit
cp -pr 32bit 64bit

%build
#64bit Build
cd 64bit
export OBJECT_MODE=64
export CC="%{__cc__} -maix64 -pthread"
export CFLAGS="-I/opt/freeware/include -fPIC -O2 -I/usr/include"
export CXX="%{__cxx__} -maix64 -pthread "
export CXXFLAGS="-I/opt/freeware/include -fPIC -O2 -I/usr/include"
./configure \
    --prefix=%{_prefix}\
    --mandir=%{_mandir}\
    --infodir=%{_infodir}
make -j4

if [ "%{dotests}" == 1 ]
then
        ( gmake -k check || true )
fi


#32bit Build
cd ../32bit
export OBJECT_MODE=32
export CC="%{__cc__} -maix32 -pthread"
export CFLAGS="-I/opt/freeware/include -fPIC -O2 -I/usr/include"
export CXX="%{__cxx__} -maix32 -pthread "
export CXXFLAGS="-I/opt/freeware/include -fPIC -O2 -I/usr/include"
./configure \
    --prefix=%{_prefix}\
    --mandir=%{_mandir}\
    --infodir=%{_infodir}
make -j4

if [ "%{dotests}" == 1 ]
then
        ( gmake -k check || true )
fi

%install
[ "${RPM_BUILD_ROOT}" != "/" ] && rm -rf ${RPM_BUILD_ROOT}

cd 64bit
make DESTDIR=${RPM_BUILD_ROOT} install
mv ${RPM_BUILD_ROOT}%{_bindir}/gperf ${RPM_BUILD_ROOT}%{_bindir}/gperf_64
/usr/bin/strip -X64 $RPM_BUILD_ROOT%{_prefix}/bin/gperf_64

cd ../32bit
make DESTDIR=${RPM_BUILD_ROOT} install
mv ${RPM_BUILD_ROOT}%{_bindir}/gperf ${RPM_BUILD_ROOT}%{_bindir}/gperf_32
/usr/bin/strip -X32 $RPM_BUILD_ROOT%{_prefix}/bin/gperf_32

#compress info files.
gzip --best ${RPM_BUILD_ROOT}%{_infodir}/*.info


#create link . Default is 64bit.
cd $RPM_BUILD_ROOT%{_prefix}/bin
ln -sf gperf_64 gperf

%post 
/sbin/install-info %{_infodir}/%{name}.info.gz %{_infodir}/dir || :


%preun 
if [ $1 = 0 ] ; then
    /sbin/install-info --delete %{_infodir}/%{name}.info.gz %{_infodir}/dir || :
fi

%files
%defattr(-,root,system,-)
%doc 64bit/README 64bit/NEWS 64bit/COPYING
%{_bindir}/*
%{_mandir}/*
%{_infodir}/%{name}.info.gz

%changelog
* Wed Dec 06 2023 Ranjit Ranjan <ranjit.ranjan@ibm.com> 3.1-1
- Initial port on AIX.
